"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _loaderUtils = require("loader-utils");

var _schemaUtils = _interopRequireDefault(require("schema-utils"));

var _getJsonConfig = _interopRequireDefault(require("get-json-config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const schema = {
  type: 'object',
  properties: {
    env: {
      type: 'string'
    },
    dir: {
      type: 'string'
    }
  }
};

function _default(content, map, meta) {
  const {
    env = process.env.NODE_ENV || 'development',
    dir = './config'
  } = (0, _loaderUtils.getOptions)(this);
  (0, _schemaUtils.default)({
    env,
    dir
  }, schema, 'Loader/Application Json Config');
  const {
    async,
    addDependency
  } = this;
  const callback = async();

  try {
    const names = JSON.parse(content);
    (0, _getJsonConfig.default)(names, {
      env,
      dir
    }).then(({
      config,
      files
    }) => {
      files.forEach(addDependency);
      callback(null, JSON.stringify(config), map, meta);
    }, error => {
      callback(error);
    });
  } catch (err) {
    throw err;
  }
}